// getProductAPI.cpp :  DLL Ӧóĵ
//

#include "stdafx.h"
#include "getProductAPI.h"
#include "restclient-cpp/restclient.h"
#include <string>
#include <map>
#include <algorithm>
#include <functional> 
#include <random> 
#include <memory>
#include "json.hpp"
#include "md5.h"


std::string g_strAppId;
std::string g_strKey;
std::string g_strLastError;
bool g_bInitCfg = false;

#if (GET_PRODUCT_API_PUBLISH == 1)  
static const std::string kSearchURL = "https://api.banmahui.cn/rest";
#else
static const std::string kSearchURL = "https://api.cuntutu.com/rest";

#endif

bool parseContent(const std::string& strJson, std::map<std::string, std::string>& dataMap);
std::string  getSearchProductData(const std::string& product_id, const std::string& district_code);
std::string  getRandomString(const size_t length);
std::string  string_format(const char * _Format, ...);
std::string UTF8_To_string(const std::string & str);
std::string string_To_UTF8(const std::string & str);


using json = nlohmann::json;

void __stdcall initCfg(const char* appid, const char* key)
{
	g_strAppId = string_To_UTF8(appid);
	g_strKey = string_To_UTF8(key);

	g_bInitCfg = true;
	
}

int  __stdcall getProductItem(IN const char* product_id, IN const char*  district_code, OUT char* title, OUT float* price)
{
	g_strLastError = "";

	if (! g_bInitCfg)
	{
		g_strLastError = "δʼ";
		return DEF_ERROR_CONFIG;
	}

	if (product_id == NULL || strlen(product_id) == 0)
	{
		g_strLastError = "product_id Ƿ";
		return DEF_ERROR_PARAM;
	}

	std::map<std::string, std::string>  headerFields;
	headerFields["User-Agent"] = "ProductClient";

	
	std::string strData = getSearchProductData(string_To_UTF8(product_id), district_code ? "": string_To_UTF8(district_code));
 
	int times = 3;
	RestClient::Response rConnect;
	while(times--)
	{
		rConnect = RestClient::post(kSearchURL, "application/json", strData, headerFields);
		
		if (rConnect.code == 200)
		{			 
			break;
		}
	}
	
	if (rConnect.code == 200)
	{
		std::map<std::string, std::string> dataMap;
		if (parseContent(rConnect.body, dataMap))
		{
			if (dataMap["return_code"] == "SUCCESS" )  // Э鼶ȷ
			{

				if (dataMap["result_code"] != "FAIL") // سɹ
				{
					std::string strTitle = dataMap["title"];
					if (title != NULL)
					{
						strcpy(title, strTitle.c_str());

					}
					if (price != NULL)
					{
						std::string strPrice = dataMap["price"];

						*price = (float)atof(strPrice.c_str());
					}

					return DEF_ERROR_SUCCESS;

				}
				else
				{

					g_strLastError = string_format("ҵʧܣerr_code=%serr_code_des=%s", dataMap["err_code"].c_str(), dataMap["err_code_des"].c_str());

					return  DEF_ERROR_NOT_FIND;

				}
				
			}
			else
			{
				g_strLastError = string_format("Эʧܣerr_code=%serr_code_des=%s", dataMap["err_code"].c_str(), dataMap["err_code_des"].c_str() );

				return DEF_ERROR_PROTOCOL;
			}

		}
		else
		{
			g_strLastError = string_format("Ϊ: %s", rConnect.body.c_str());
			return DEF_ERROR_PARSE;

		}



	}
	else
	{
		g_strLastError = string_format( "󣬴: %d", rConnect.code);
		return DEF_ERROR_NET;
	}



	return 0;
}

int  __stdcall getLastError(OUT char* szError)
{
	strcpy(szError, g_strLastError.c_str());
	return 0;
}



std::string UTF8_To_string(const std::string & str)
{
	int nwLen = MultiByteToWideChar(CP_UTF8, 0, str.c_str(), -1, NULL, 0);

	wchar_t * pwBuf = new wchar_t[nwLen + 1];//һҪ1Ȼβ 
	memset(pwBuf, 0, nwLen * 2 + 2);

	MultiByteToWideChar(CP_UTF8, 0, str.c_str(), str.length(), pwBuf, nwLen);

	int nLen = WideCharToMultiByte(CP_ACP, 0, pwBuf, -1, NULL, NULL, NULL, NULL);

	char * pBuf = new char[nLen + 1];
	memset(pBuf, 0, nLen + 1);

	WideCharToMultiByte(CP_ACP, 0, pwBuf, nwLen, pBuf, nLen, NULL, NULL);

	std::string retStr = pBuf;

	delete[]pBuf;
	delete[]pwBuf;

	pBuf = NULL;
	pwBuf = NULL;

	return retStr;
}


std::string string_To_UTF8(const std::string & str)
{
	int nwLen = ::MultiByteToWideChar(CP_ACP, 0, str.c_str(), -1, NULL, 0);

	wchar_t * pwBuf = new wchar_t[nwLen + 1];//һҪ1Ȼβ 
	ZeroMemory(pwBuf, nwLen * 2 + 2);

	::MultiByteToWideChar(CP_ACP, 0, str.c_str(), str.length(), pwBuf, nwLen);

	int nLen = ::WideCharToMultiByte(CP_UTF8, 0, pwBuf, -1, NULL, NULL, NULL, NULL);

	char * pBuf = new char[nLen + 1];
	ZeroMemory(pBuf, nLen + 1);

	::WideCharToMultiByte(CP_UTF8, 0, pwBuf, nwLen, pBuf, nLen, NULL, NULL);

	std::string retStr(pBuf);

	delete[]pwBuf;
	delete[]pBuf;

	pwBuf = NULL;
	pBuf = NULL;

	return retStr;
}


std::string  string_format(const char * _Format, ...)
{
	//std::string strRet;
	va_list marker = NULL;
	va_start(marker, _Format);

	int num_of_chars = _vscprintf(_Format, marker) + 1;

	std::unique_ptr<char[]> buf(new char[num_of_chars]);

	vsprintf((char *)buf.get(), _Format, marker);

	va_end(marker);
	return std::string(buf.get(), buf.get() + num_of_chars - 1);
	
}

std::string getRandomString(const size_t length) 
{
	const std::string
		chars("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
	std::default_random_engine rng(std::random_device{}());
	std::uniform_int_distribution<> dist(0, static_cast<int>(chars.size()) - 1);
	std::string result(length, '0');
	for (auto& chr : result) {
		chr = chars[dist(rng)];
	}
	return result;
}

std::string getSearchProductData(const std::string& product_id, const std::string& district_code)
{

	std::map<std::string, std::string> paramsMap;

	paramsMap["version"] = "1.0.0";
	paramsMap["method"] = "item.product.get";
	paramsMap["charset"] = "UTF-8";
	paramsMap["sign_type"] = "MD5";
	paramsMap["appid"] = g_strAppId;
	paramsMap["nonce_str"] = getRandomString(8);
	paramsMap["product_id"] = product_id;

	if (! district_code.empty())
	{
		paramsMap["district_code"] = district_code;

	}


	std::string strParam;
	for (auto it : paramsMap)
	{
		strParam += it.first;
		strParam += "=" + it.second + "&";

	}

	strParam += "key=" + g_strKey;

	std::string sign_key_md5 = MD5(strParam).toStr();
	std::transform(sign_key_md5.begin(), sign_key_md5.end(), sign_key_md5.begin(), ::toupper);

	paramsMap["sign"] = sign_key_md5;

	json JsonData;
	for (auto itr : paramsMap)
	{
		JsonData[itr.first] = itr.second;

	}
	std::string strJson;
	strJson = JsonData.dump();

	return strJson;
}

bool parseContent(const std::string& strJson, std::map<std::string,std::string>& dataMap)
{
	try
	{
		json  jsonRoot = json::parse(strJson);

		for (json::iterator it = jsonRoot.begin(); it != jsonRoot.end(); ++it) 
		{		 
			if ((*it).is_string())
			{
				dataMap[it.key()] = UTF8_To_string(it.value());
			}
			else if (it.value().is_number_integer())
			{
				dataMap[it.key()] = string_format("%I64d", it.value());

			}
			else if (it.value().is_number_float())
			{
				dataMap[it.key()] = string_format("%lf", it.value());

			}
		}
		
	}
	catch (json::exception& )
	{
		return false;
	}



	return true;
}

